setwd ('/home/allgoodguys/Documents/Studying/Lund_PhD/epistles/01_article_ratings/analysis_final')

## Preparing the datasets
anal <- read.csv("acoustic-analysis_shortened_oct16.csv")
# anal <- read.csv("lima.csv")
# anal <- read.csv("belin.csv")

anal$sex = as.factor (ifelse (anal$sex=="m", "AM", "OTHER"))
anal$HNR_exc = anal$HNR_max - anal$HNR_mean  # HNR_min no good, so I subtract "HNR" from max instead
# Note: HNR_exc shows which calls have very tonal AND noisy segments - very different from HNR
anal$pitch_exc = anal$pitch_max - anal$pitch_min

write.csv (anal, "anal_preprocessed_with-NA.csv")

# Re-encode mean_interval, sd_interval, syllableLength_sd, interBurst_mean, interBurst_sd
anal$mean_interval = as.character (anal$mean_interval)
anal$sd_interval = as.character (anal$sd_interval)
anal$syllableLength_sd = as.character (anal$syllableLength_sd)
anal$interBurst_mean = as.character (anal$interBurst_mean)
anal$interBurst_sd = as.character (anal$interBurst_sd)

for (i in 1:nrow(anal)) {
  if (anal$mean_interval[i]=="undef") {anal$mean_interval[i]=10}  
  if (anal$sd_interval[i]=="undef") {anal$sd_interval[i]=10}
  if (anal$syllableLength_sd[i]=="undef") {anal$syllableLength_sd[i]=10000}
  if (anal$interBurst_mean[i]=="undef") {anal$interBurst_mean[i]=10000}
  if (anal$interBurst_sd[i]=="undef") {anal$interBurst_sd[i]=10000}
}

write.csv (anal, 'anal_preprocessed_without-NA.csv')
# write.csv (anal, 'lima_preprocessed_without-NA.csv')
# write.csv (anal, 'belin_preprocessed_without-NA.csv')


## 260-set
compiled = read.csv ('compiled_preprocessed.csv')
ut260 = anal [match (compiled$sound, paste0(anal$file,'.mp3') ),]
write.csv (ut260, 'ut260_without-NA.csv')
