setwd ('/home/allgoodguys/Documents/Studying/Lund_PhD/epistles/01_article_ratings/analysis_final')

compiled = read.csv ("ratings_compiled_preprocessed.csv")

## Descriptives
table (compiled$real.em,compiled$sex)  # Table 1

# responses per sound
range (compiled$shown); range (compiled$rated)
mean (compiled$shown); mean (compiled$rated)
sd (compiled$shown); sd (compiled$rated)
mean (compiled$skipped); sd (compiled$skipped)

## Table 2 - confusion matrix, vox populi
x = as.matrix (table (compiled$real.em, compiled$emotion))
# write.csv (x, "~/Downloads/temp.csv") # open in calc and copy-paste into writer

out = data.frame (emotion=sort(unique(compiled$emotion)),correctDetection=NA,incorrectDetection=NA,correctRejection=NA,incorrectRejection=NA,Hu=NA,chance=NA)
for (i in 1:nrow(x)) {
  out$correctDetection[i] = round (x[i,i] / sum(x[i,]),3) # we say "amusement" given that it is amusement
  out$incorrectDetection[i] = round ( sum(x[-i,i]) / sum(x[-i,]),3) # we say "amusement" given that it is not amusement
  out$correctRejection[i] = round ( sum(x[-i,-i]) / sum(x[-i,]) ,3) # we say "not amusement" given that it is not amusement
  out$incorrectRejection[i] = round ( sum(x[i,-i]) / sum(x[i,]),3) # we say "not amusement" given that it is amusement
  out$Hu[i] = round (x[i,i]^2 / (sum(x[,i])*sum(x[i,])),3)
  out$chance[i] = round ( sum(x[,i])*sum(x[i,])/(sum(x)^2),3 )
}
out[, 2:ncol(out)] = out[, 2:ncol(out)] * 100
# write.csv (out, "~/Downloads/temp.csv")

# to get CI's for hit rates:
library (MCMCglmm)
mod1 = MCMCglmm (correct~real.em, data=compiled, family='categorical', nitt = 50000) 
plot (mod1) # converges very nicely
# summary(mod1)
p = cbind (compiled, predict(mod1, type = "response", interval = "confidence"))
pred = matrix(ncol=2,nrow=9)
pred[,1] = levels(compiled$real.em)
for (i in 1:nrow(pred)) {
  subdf = p[p$real.em==levels(p$real.em)[i], ( (ncol(p)-2): ncol(p))]
  hitRate = out$correctDetection[i]  # to use the posterior, take round ( subdf[1,1]*100, 1 )
  low = round ( subdf[1,2]*100, 1 )
  high = round ( subdf[1,3]*100, 1 )
  pred[i,2] = paste0 ( hitRate, ' [', low, ', ', high, ']'  )
}
write.csv (pred, '~/Downloads/temp.csv')

# overall:
mean (compiled$correct) # gives mean overall hit rate
mod_overall = MCMCglmm (correct~1, data=compiled, family='categorical', nitt = 50000)
predict(mod_overall, type = "response", interval = "confidence") [1, 2:3] # gives CI

mean (out$Hu)
mean (out$chance)
