setwd ('/home/allgoodguys/Documents/Studying/Lund_PhD/epistles/01_article_ratings/analysis_final')

giant <- read.csv("ratings_raw-responses.csv")[,-1]

## Table 2 - confusion matrix, individual accuracy
x = as.matrix (table (giant$real.em, giant$pred.em))
# write.csv (x, "~/Downloads/temp.csv") # open in calc and copy-paste into writer

out = data.frame (emotion=sort(unique(giant$real.em)),correctDetection=NA,incorrectDetection=NA,correctRejection=NA,incorrectRejection=NA,Hu=NA,chance=NA)
for (i in 1:nrow(x)) {
  out$correctDetection[i] = round (x[i,i] / sum(x[i,]),3) # we say "amusement" given that it is amusement
  out$incorrectDetection[i] = round ( sum(x[-i,i]) / sum(x[-i,]),3) # we say "amusement" given that it is not amusement
  out$correctRejection[i] = round ( sum(x[-i,-i]) / sum(x[-i,]) ,3) # we say "not amusement" given that it is not amusement
  out$incorrectRejection[i] = round ( sum(x[i,-i]) / sum(x[i,]),3) # we say "not amusement" given that it is amusement
  out$Hu[i] = round (x[i,i]^2 / (sum(x[,i])*sum(x[i,])),3)
  out$chance[i] = round ( sum(x[,i])*sum(x[i,])/(sum(x)^2),3 )
}
out[, 2:ncol(out)] = out[, 2:ncol(out)] * 100

# write.csv (out, "~/Downloads/temp.csv")

# to get CI's for hit rates:
library (MCMCglmm)
mod1 = MCMCglmm (correct~real.em, random = ~file+sound, data=giant, family='categorical', nitt=20000, burnin=10000, thin=1) 
plot (mod1) # converges very nicely
# summary(mod1)
p = cbind (giant, predict(mod1, type = "response", interval = "confidence", marginal = ~file+sound))  # w/o specifying the marginal, we get the same results (?)
pred = matrix(ncol=2,nrow=9)
pred[,1] = levels(giant$real.em)
for (i in 1:nrow(pred)) {
  subdf = p[p$real.em==levels(p$real.em)[i], ( (ncol(p)-2): ncol(p))]
  hitRate = out$correctDetection[i]  # to use the posterior, take round ( subdf[1,1]*100, 1 )
  low = round ( subdf[1,2]*100, 1 )
  high = round ( subdf[1,3]*100, 1 )
  pred[i,2] = paste0 ( hitRate, ' [', low, ', ', high, ']'  )
}
write.csv (pred, '~/Downloads/temp.csv')

# overall:
mean (giant$correct) # gives mean overall hit rate
mod_overall = MCMCglmm (correct~1, random = ~file+sound, data=giant, family='categorical', nitt=20000, burnin=10000, thin=1)
predict(mod_overall, type = "response", interval = "confidence", marginal = ~file+sound) [1, 2:3] # gives CI

mean (out$Hu)
mean (out$chance)


# do all participants use the entire scale, from 0 to 100?
out = matrix(ncol=2, nrow=length(levels(giant$file)))
for (p in 1:length(levels(giant$file))) {
  temp = subset (giant, giant$file == levels(giant$file)[p])
  out[p,] = range(temp[,2:10])
}
table (out[,2]-out[,1])

