setwd ('/home/allgoodguys/Documents/Studying/Lund_PhD/epistles/01_article_ratings/analysis_final')

giant <- read.csv("ratings_raw-responses.csv")[,-1]

m = subset (giant, giant$no.emotions>1) # or m = subset (giant, giant$no.emotions==2) to limit analysis to the trials in which exactly two emotions were picked

em = m[,2:10]
em[em>=1] <- 1
em = t(em)
em = em[ order(rownames(em)), ]  # to have emotions in alphabetic order - good for comparing with triplets, etc
termMatrix <- em %*% t(em)  # nrow(subset(m, m$amusement>0 & m$anger>0)) gives 9, etc. Diagonal - how many times this label was used in total (in any combination, but not alone)

library(igraph)
g <- graph.adjacency(termMatrix, weighted=T, mode = "undirected")
# remove loops
g <- simplify(g)
# set labels and degrees of vertices
V(g)$label <- V(g)$name
V(g)$degree <- degree(g)
V(g)$label.color <- 'red'
egam <- E(g)$weight

# Spinglass community detection
spc <- spinglass.community(g, spins=3)
spc

## MDS termMatrix
dm = as.dist (termMatrix); dm = max(dm)-dm   # to go from proximities to distances
plot (prcomp(dm)) 
summary (prcomp(dm))  # first PC explains 51% of variance, 2 PCs explain 67% of var, 3 PCs 81%
mod3d = as.matrix (cmdscale (dm, k=3))

require(rgl)
rglplot(g, layout=mod3d, vertex.size=10, vertex.label.dist=.2, edge.color=rgb(.1,.8,0.1,.1), vertex.color=spc$membership+1, vertex.label.color=spc$membership+1, asp=FALSE, edge.width = .02*egam)  # vertex.label.cex=2 - not implemented in rglplot... :(
# rgl.bbox(xlen = 0, ylen = 0, zlen = 0, color = c('gray50'), emission='gray50', expand=1.2) 
# axes3d(c('x', 'y', 'z'), pos=c(-.9,-.7,-1), tick=F, nticks=2, box='bbox')
axes3d(edges = "bbox", labels = F, tick = F, nticks = 2, box=FALSE, expand = 1)

# rgl.snapshot('~/Downloads/temp.jpg')
rgl.postscript("~/Downloads/temp.svg", fmt="svg") # open this in gimp and choose the required size and resolution! :))

movie3d( spin3d(), duration=12, dir = '~/Downloads/' )  # make a movie. 12 gives a full 360° circle. 
